"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunk6TCZFTKDcjs = require('./chunk-6TCZFTKD.cjs');



var _chunkTJP5RDJEcjs = require('./chunk-TJP5RDJE.cjs');







var _chunkJ42M6DF3cjs = require('./chunk-J42M6DF3.cjs');


var _chunk52BL3727cjs = require('./chunk-52BL3727.cjs');

// src/common/log/log-context.ts
function LoggerContext(_prefix = "") {
  let logHandlers = [_chunk6TCZFTKDcjs.LoggerConsoleHandler.call(void 0, )];
  let logCheckNamespace = (_name) => true;
  let logLock = false;
  let logFactory = LoggerBaseFactory;
  let logDebug = false;
  function LoggerBaseFactory(name = "", level) {
    const logLevel = _chunkTJP5RDJEcjs.parseLogLevel.call(void 0, _nullishCoalesce(level, () => ( _chunkJ42M6DF3cjs.LogLevelAll)));
    function defineForLogLevel(fnLevel, fn) {
      if (logLevel <= fnLevel)
        return fn;
      return () => {
      };
    }
    const emit = (msg) => {
      if (logCheckNamespace(name)) {
        for (const handler of logHandlers) {
          if (handler)
            handler(msg);
        }
      }
    };
    const log = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelDebug, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelDebug });
    });
    log.label = name;
    log.extend = function(prefix) {
      return logFactory(name ? `${name}:${prefix}` : prefix);
    };
    log.debug = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelDebug, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelDebug });
    });
    log.info = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelInfo, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelInfo });
    });
    log.warn = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelWarn, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelWarn });
    });
    log.error = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelError, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelError });
    });
    log.fatal = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelFatal, (...messages) => {
      emit({ name, messages, level: _chunkJ42M6DF3cjs.LogLevelFatal });
      throw new Error(`${messages.map(String).join(" ")}`);
    });
    log.assert = defineForLogLevel(_chunkJ42M6DF3cjs.LogLevelFatal, (condition, ...args) => {
      if (condition == null || typeof condition === "number" && Number.isNaN(condition) || !condition)
        log.fatal(...args);
    });
    return log;
  }
  function Logger(name = "", level) {
    const log = logFactory(name, level);
    if (logDebug)
      log.debug(`+++ init of logger "${name}" on level "${log.level}".`);
    return log;
  }
  Logger.registerHandler = function(handler) {
    logHandlers.push(handler);
  };
  Logger.setFilter = function(namespaces) {
    logCheckNamespace = _chunkTJP5RDJEcjs.useNamespaceFilter.call(void 0, namespaces);
  };
  Logger.setLock = (lock = true) => logLock = lock;
  Logger.setDebug = (debug = true) => logDebug = debug;
  Logger.setHandlers = (handlers) => {
    if (logFactory !== LoggerBaseFactory)
      logFactory = LoggerBaseFactory;
    if (handlers != null && !logLock)
      logHandlers = [...handlers].filter(_chunk52BL3727cjs.isNotNull);
  };
  Logger.level = _chunkJ42M6DF3cjs.LogLevelAll;
  Logger.setLogLevel = function(level = _chunkJ42M6DF3cjs.LogLevelAll) {
    if (logLock)
      return;
    Logger.level = level;
  };
  Logger.setFactory = function(factory) {
    if (logLock)
      return;
    logFactory = factory;
  };
  return Logger;
}



exports.LoggerContext = LoggerContext;
//# sourceMappingURL=chunk-ABEJKCAO.cjs.map