"use strict";










var _chunkGU6AYGWKcjs = require('../../chunk-GU6AYGWK.cjs');


var _chunkCEXYDYSHcjs = require('../../chunk-CEXYDYSH.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-6T6PI6XG.cjs');

// src/common/data/rounding.spec.ts
describe("currency", () => {
  describe("down", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, 1.4)).toBe(1);
    });
    it("rounds down with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, -1.4)).toBe(-2);
    });
    it("rounds down with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, 1.5)).toBe(1);
    });
    it("rounds down with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, -1.5)).toBe(-2);
    });
    it("rounds down with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, 1.6)).toBe(1);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundDown.call(void 0, -1.6)).toBe(-2);
    });
  });
  describe("halfAwayFromZero", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, 1.4)).toBe(1);
    });
    it("rounds up with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds to the nearest integer away from zero with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, 1.5)).toBe(2);
    });
    it("rounds to the nearest integer away from zero with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, -2.5)).toBe(-3);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, 1.6)).toBe(2);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfAwayFromZero.call(void 0, -1.6)).toBe(-2);
    });
  });
  describe("halfDown", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, 1.4)).toBe(1);
    });
    it("rounds down with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds down with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, 1.5)).toBe(1);
    });
    it("rounds down with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, -1.5)).toBe(-2);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, 1.6)).toBe(2);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfDown.call(void 0, -1.6)).toBe(-2);
    });
  });
  describe("halfEven", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, 1.4)).toBe(1);
    });
    it("rounds down with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds to nearest even integer with a positive half float rounding to an even integer", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, 1.5)).toBe(2);
    });
    it("rounds to nearest even integer with a positive half float rounding to an odd integer", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, 2.5)).toBe(2);
    });
    it("rounds to nearest even integer with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, -2.5)).toBe(-2);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, 1.6)).toBe(2);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfEven.call(void 0, -1.6)).toBe(-2);
    });
  });
  it("rounds down with a positive float below half", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, 1.4)).toBe(1);
  });
  it("rounds down with a negative float below half", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, -1.4)).toBe(-1);
  });
  it("rounds to nearest odd integer with a positive half float rounding to an even integer", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, 1.5)).toBe(1);
  });
  it("rounds to nearest odd integer with a positive half float rounding to an odd integer", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, 2.5)).toBe(3);
  });
  it("rounds to nearest odd integer with a negative half float", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, -2.5)).toBe(-3);
  });
  it("rounds up with a positive float above half", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, 1.6)).toBe(2);
  });
  it("rounds down with a negative float above half", () => {
    expect(_chunkGU6AYGWKcjs.roundHalfOdd.call(void 0, -1.6)).toBe(-2);
  });
  describe("halfTowardsZero", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, 1.4)).toBe(1);
    });
    it("rounds up with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds to the nearest integer towards zero with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, 1.5)).toBe(1);
    });
    it("rounds to the nearest integer towards zero with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, -2.5)).toBe(-2);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, 1.6)).toBe(2);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfTowardsZero.call(void 0, -1.6)).toBe(-2);
    });
  });
  describe("halfUp", () => {
    it("rounds down with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, 1.4)).toBe(1);
    });
    it("rounds down with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds up with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, 1.5)).toBe(2);
    });
    it("rounds up with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, -2.5)).toBe(-2);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, 1.6)).toBe(2);
    });
    it("rounds down with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundHalfUp.call(void 0, -1.6)).toBe(-2);
    });
  });
  describe("up", () => {
    it("rounds up with a positive float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, 1.4)).toBe(2);
    });
    it("rounds up with a negative float below half", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, -1.4)).toBe(-1);
    });
    it("rounds up with a positive half float", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, 1.5)).toBe(2);
    });
    it("rounds up with a negative half float", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, -1.5)).toBe(-1);
    });
    it("rounds up with a positive float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, 1.6)).toBe(2);
    });
    it("rounds up with a negative float above half", () => {
      expect(_chunkGU6AYGWKcjs.roundUp.call(void 0, -1.6)).toBe(-1);
    });
  });
  it("distribute percentages", () => {
    const values = [13.626332, 47.989636, 9.596008, 28.788024];
    const objs = [{
      name: "13",
      percent: 13.626332
    }, {
      name: "47",
      percent: 47.989636
    }, {
      name: "9",
      percent: 9.596008
    }, {
      name: "28",
      percent: 28.788024
    }];
    expect(_chunkCEXYDYSHcjs.arraySum.call(void 0, _chunkGU6AYGWKcjs.roundArrayOfNumbersToMatchSum.call(void 0, values))).toEqual(100);
    expect(_chunkCEXYDYSHcjs.arraySum.call(void 0, _chunkGU6AYGWKcjs.roundArrayOfNumbersToMatchSum.call(void 0, values, 95, 2))).toEqual(95);
    expect(_chunkGU6AYGWKcjs.roundArrayOfNumbersToMatchSum.call(void 0, values)).toMatchInlineSnapshot(`
      Array [
        14,
        48,
        9,
        29,
      ]
    `);
    expect(_chunkGU6AYGWKcjs.roundArrayOfNumbersToMatchSum.call(void 0, values, 95, 2)).toMatchInlineSnapshot(`
      Array [
        12.94,
        45.59,
        9.12,
        27.35,
      ]
    `);
    expect(_chunkGU6AYGWKcjs.roundArrayOfObjectsToMatchSum.call(void 0, objs, "percent")).toMatchInlineSnapshot(`
      Array [
        Object {
          "name": "13",
          "percent": 14,
        },
        Object {
          "name": "47",
          "percent": 48,
        },
        Object {
          "name": "9",
          "percent": 9,
        },
        Object {
          "name": "28",
          "percent": 29,
        },
      ]
    `);
  });
});
//# sourceMappingURL=rounding.spec.cjs.map