"use strict";

var _chunkTXDENP25cjs = require('../../chunk-TXDENP25.cjs');
require('../../chunk-C24GLBSD.cjs');
require('../../chunk-UNHMDTJQ.cjs');
require('../../chunk-3EDAYL42.cjs');
require('../../chunk-ZO3HNLXY.cjs');
require('../../chunk-JYYZK5M3.cjs');
require('../../chunk-XONRCJCB.cjs');
require('../../chunk-4E3SFF2S.cjs');
require('../../chunk-QKLU3LNT.cjs');
require('../../chunk-QLGR2XSS.cjs');
require('../../chunk-QZHRO76T.cjs');
require('../../chunk-J2UQ7CEL.cjs');
require('../../chunk-BQ6MKKYS.cjs');
require('../../chunk-6LTOCALJ.cjs');
require('../../chunk-4B2XCWGL.cjs');
require('../../chunk-5CIFX7O6.cjs');
require('../../chunk-ON3N7H7T.cjs');
require('../../chunk-XC7SHABV.cjs');
require('../../chunk-ABEJKCAO.cjs');
require('../../chunk-6TCZFTKD.cjs');
require('../../chunk-U7QCFBCQ.cjs');
require('../../chunk-UKD65B23.cjs');
require('../../chunk-TJP5RDJE.cjs');
require('../../chunk-J42M6DF3.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-L646RZQB.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-XV5FJ2SJ.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-RZKLDILW.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-RKOTNV3K.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-GU6AYGWK.cjs');
require('../../chunk-SNRM7OTJ.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-NTCZ6VPJ.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-XVQVWCIE.cjs');
require('../../chunk-52BL3727.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-JQSCYOKH.cjs');
require('../../chunk-L5SJIWCK.cjs');
require('../../chunk-EE5CB3R7.cjs');
require('../../chunk-QYCE2TUJ.cjs');
require('../../chunk-5KIDARFB.cjs');
require('../../chunk-CEXYDYSH.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-37LFQPGN.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-7FO3T7KH.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-QP5Y3I6F.cjs');
require('../../chunk-TAKWLGAZ.cjs');

// src/common/exec/progress.spec.ts
describe("progress.spec", () => {
  it("should track progress", async () => {
    const p = new (0, _chunkTXDENP25cjs.Progress)({
      name: "root",
      totalUnits: 10
    });
    expect(p.getFraction()).toBe(0);
    p.incCompletedUnits();
    expect(p.getTotalUnits()).toBe(10);
    expect(p.getCompletedUnits()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    const pp = new (0, _chunkTXDENP25cjs.Progress)();
    p.addChild(pp);
    expect(p.getChildrenCount()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    pp.setTotalUnits(10);
    expect(p.getFraction()).toBe(0.05);
    pp.incCompletedUnits(5);
    expect(p.getTotalUnits()).toBe(20);
    expect(p.getCompletedUnits()).toBe(6);
    expect(p.getFraction()).toBe(0.3);
    expect(p.toString()).toMatchInlineSnapshot(`
      "root: 1 of 10 units, 30 %, cancel=false
        progress-0: 5 of 10 units, 50 %, cancel=false"
    `);
    expect(pp.isFinished()).toBe(false);
    expect(p.getChildrenCount()).toBe(1);
    await pp.dispose();
    expect(p.getChildrenCount()).toBe(0);
    expect(pp.isFinished()).toBe(true);
    expect(p.getTotalUnits()).toBe(10);
    expect(p.getCompletedUnits()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    expect(p.isFinished()).toBe(false);
    p.setCompletetedUnits(10);
    expect(p.getFraction()).toBe(1);
    expect(p.isFinished()).toBe(true);
  });
  it("should cancel and auto reset", async () => {
    const p = new (0, _chunkTXDENP25cjs.Progress)({
      totalUnits: 10
    });
    expect(p.isCancelled()).toBe(false);
    await p.cancel();
    expect(p.isCancelled()).toBe(true);
    p.incCompletedUnits(10);
    expect(p.isFinished()).toBe(true);
    expect(p.isCancelled()).toBe(false);
  });
});
//# sourceMappingURL=progress.spec.cjs.map