"use strict";



var _chunkSH6VLUBJcjs = require('../chunk-SH6VLUBJ.cjs');
require('../chunk-TZOPYZVR.cjs');
require('../chunk-M46XHZ6B.cjs');
require('../chunk-IB5IYYW3.cjs');
require('../chunk-Q2SNIYQS.cjs');
require('../chunk-MBFXWDW2.cjs');
require('../chunk-IKIQVPMW.cjs');
require('../chunk-JCNZZG5S.cjs');
require('../chunk-MISU7G26.cjs');
require('../chunk-SFUIGVPA.cjs');
require('../chunk-X23ZSPZC.cjs');
require('../chunk-2UTQQDPY.cjs');
require('../chunk-MJ7L4G3V.cjs');
require('../chunk-V6M22LNO.cjs');
require('../chunk-LKES6YKV.cjs');
require('../chunk-3TNVJY4F.cjs');
require('../chunk-WPWV7ZEM.cjs');
require('../chunk-H6AB4FMJ.cjs');
require('../chunk-62TCRE2J.cjs');
require('../chunk-4HLDMY5U.cjs');
require('../chunk-TXDENP25.cjs');
require('../chunk-C24GLBSD.cjs');
require('../chunk-UNHMDTJQ.cjs');
require('../chunk-3EDAYL42.cjs');
require('../chunk-ZO3HNLXY.cjs');
require('../chunk-JYYZK5M3.cjs');
require('../chunk-XONRCJCB.cjs');
require('../chunk-4E3SFF2S.cjs');
require('../chunk-QKLU3LNT.cjs');
require('../chunk-QLGR2XSS.cjs');
require('../chunk-QZHRO76T.cjs');
require('../chunk-J2UQ7CEL.cjs');
require('../chunk-BQ6MKKYS.cjs');
require('../chunk-6LTOCALJ.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-5CIFX7O6.cjs');
require('../chunk-ON3N7H7T.cjs');
require('../chunk-XC7SHABV.cjs');
require('../chunk-ABEJKCAO.cjs');
require('../chunk-6TCZFTKD.cjs');
require('../chunk-U7QCFBCQ.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-TJP5RDJE.cjs');
require('../chunk-J42M6DF3.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-L646RZQB.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-XV5FJ2SJ.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-RZKLDILW.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-GU6AYGWK.cjs');
require('../chunk-SNRM7OTJ.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-NTCZ6VPJ.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-XVQVWCIE.cjs');
require('../chunk-52BL3727.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-JQSCYOKH.cjs');
require('../chunk-L5SJIWCK.cjs');
require('../chunk-EE5CB3R7.cjs');
require('../chunk-QYCE2TUJ.cjs');
require('../chunk-5KIDARFB.cjs');
require('../chunk-CEXYDYSH.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-37LFQPGN.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-7FO3T7KH.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-QP5Y3I6F.cjs');
require('../chunk-TAKWLGAZ.cjs');

// src/node/files-async.spec.ts
describe("getStatAsync", () => {
  it("should return the stat object for a valid path", async () => {
    const path = __filename;
    const statObject = await _chunkSH6VLUBJcjs.getStatAsync.call(void 0, path);
    expect(statObject).toBeDefined();
    expect(statObject.isFile()).toBe(true);
  });
  it("should return undefined for an invalid path", async () => {
    const path = "/invalid/path";
    const statObject = await _chunkSH6VLUBJcjs.getStatAsync.call(void 0, path);
    expect(statObject).toBeUndefined();
  });
  it("should return the fingerprint for a valid path", async () => {
    const path = __filename;
    const fingerprint = await _chunkSH6VLUBJcjs.getFingerprintAsync.call(void 0, path);
    expect(fingerprint).toBeDefined();
    expect(typeof fingerprint).toBe("string");
  });
  it("should return undefined for an invalid path 2", async () => {
    const path = "/invalid/path";
    const fingerprint = await _chunkSH6VLUBJcjs.getFingerprintAsync.call(void 0, path);
    expect(fingerprint).toBeUndefined();
  });
  it("should return an array of file paths", async () => {
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
  });
  it("should return an array of file paths matching the pattern", async () => {
    const pattern = "*.ts";
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname, pattern });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
    expect(paths.every((path) => path.endsWith(".ts"))).toBe(true);
  });
  it("should return an empty array if no files match the pattern", async () => {
    const pattern = "*.docx";
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname, pattern });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBe(0);
  });
  it("should return an array of file paths filtered by the custom filter function", async () => {
    const filter = (name) => name.includes("spec");
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname, filter });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
    expect(paths.every((path) => path.includes("spec"))).toBe(true);
  });
  it("should return an empty array if no files pass the custom filter function", async () => {
    const filter = (name) => name.includes("xyz");
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname, filter });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBe(0);
  });
  it("should ignore hidden files by default", async () => {
    const paths = await _chunkSH6VLUBJcjs.filesAsync.call(void 0, { basePath: __dirname });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.every((path) => !path.includes("/."))).toBe(true);
  });
});
//# sourceMappingURL=files-async.spec.cjs.map